; GIMP -- an image manipulation program
; Copyright (C) 1995 Spencer Kimball and Peter Mattis
; 
; AquaPro2 script for GIMP 2.10.28 that creates Aqua Style Button 
; Copyright (C) 2001 Denis Bodor <b.bodor@calixo.net> creator of the original Perl-Fu script aquabou.pl http://www.linuxmag-france.org/redactor_zone/aquapl.html
; Copyright (C) 2001-2002 Iccii <iccii@hotmail.com>   Translation into Script-Fu 
; Copyright (C) 2021 Nidhogg, AlSchemist			  Optimization
; -------------------------------------------------------------------- Historic
; v 1.0  by Iccii      2001/09/14: Initial relase (aquabou.scm). This version is directly translation version from Perl-Fu
; v 1.1     Iccii      2001/09/17: Second relase (aquabou2.scm). Added two setting options which enable adjustment Width and Height
; v 1.1a    Iccii      2001/11/01: Fixed wrong parameter name ...Thanks to _tom_
; v 1.2     Iccii      2001/11/02: Added creating logo in aqua pill (script-fu-aquapro2-button). Note that this relase has bugs in some situations
; v 1.2a    Iccii      2001/11/06: Fixed above bugs. Moved menu path from  <Xtns>/Script-Fu/AquaPro2* to <Xtns>/Script-Fu/Web Page Themes/AquaPro2/*
; v 1.3     Iccii      2001/11/07: Added new image creation function (script-fu-aquapro2-round, script-fu-aquapro2-logo-in-ball). Changed the top reflecting fusion
; v 1.3a    Iccii      2001/11/08: Now, script-fu-aquapro2-logo-in-ball function allows white space in string to split into each balls per words
; v 1.3b    Iccii      2001/11/09: Adjusted the top highlight reflection (looks better)
; v 1.3b    Iccii      2001/11/12: Added "Transparent BG" toggle (Thanks to Darryn Lowe for advising)
; v 1.3c    Iccii      2001/11/12: Fixed crazzy background color. Added undo stuff (try enter Ctrl-Z)
; v 1.3d    Iccii      2002/01/17: Looks more better background color. Renamed "Logo in Ball" to "Logo in Pill". Deleted "Apply Lens" option in "Logo in Pill"
; v 1.3e    Iccii      2002/01/26: Fixed drop shadow bug (thanks to KINO).
; v 2.10    Nidhogg    2021/05/31: Gimp 2.8 => Gimp 2.10. Fixed displace type & LINEAR                        867 lines
; v 2.10.28 AlSchemist 2021/11/16: Gimp 2.10.28 +shortcut +menu registration +optimization (* 512 2) => 1024. 333 lines
; -------------------------------------------------------------------- GNU General Public License 
; # This program is free software; you can redistribute it and/or modify it under the terms of the GNU General Public License   
; # as published by the Free Software Foundation; either version 2 of the License, or (at your option) any later version.
; # This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of
; # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.
; # You should have received a copy of the GNU General Public License along with this program; 
; # if not, write to the Free Software Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
(define	(script-fu-aqua-button2 width height coulop coulfg coulbg coulgrad 	coultex coullt disp?)
	(define (colop-switch image layer x1 y1 x2 y2 isZero? isSelect?)
		(case coulop	((0)(if isZero? (gimp-edit-fill layer FILL-FOREGROUND)))
						((1)(gimp-context-set-gradient coulgrad)
							(gimp-edit-blend layer BLEND-CUSTOM LAYER-MODE-NORMAL-LEGACY 0 100 20 REPEAT-NONE FALSE 0 0 0 0 0 0 width height)
						)
						((2)(if isSelect? (gimp-image-select-item image CHANNEL-OP-REPLACE layer))
							(gimp-context-set-pattern coultex)
							(gimp-edit-bucket-fill layer BUCKET-FILL-PATTERN LAYER-MODE-NORMAL-LEGACY 100 255 FALSE 0 0)
	)	)				)
	(define	(script-fu-disp img oc1 coulop coulgrad coultex width height) ; Displace
		(let*	(	(oc2 (car (gimp-layer-copy oc1 0))))		;create layer copy
			(gimp-image-insert-layer img oc2 0 0)					;add layer
			(let*	(	(oc3 (car (gimp-layer-copy oc2 0))))	;create layer copy
				(gimp-selection-all img)
				(colop-switch img oc1 0 0 width height #f #f)
				(gimp-edit-clear oc2)
				(gimp-selection-none img)
				(gimp-image-insert-layer img oc3 0 0)			;add 2.8
				(gimp-image-select-item img CHANNEL-OP-REPLACE oc3)
				(gimp-selection-feather img (/ height 10))	;blur
				(gimp-context-set-foreground '(0 0 0))
				(gimp-edit-fill oc2 FILL-FOREGROUND)
				(gimp-selection-none img)
				(plug-in-displace 1 img oc1 (* (/ width 525) 15) (* (/ height 125) 20) TRUE TRUE oc2 oc2 1)
				(gimp-image-select-item img CHANNEL-OP-REPLACE oc3)
				(gimp-selection-invert img)					;invert selection
				(gimp-edit-clear oc1)						;delete selection
				(gimp-selection-none img)
				(gimp-image-remove-layer img oc3)			;add 2.8
				(gimp-image-remove-layer img oc2)			;delete layer
	)	)	)
	(define (layer-new image width height name opacity position mode) ; Create a new layer, add it to image then edit-clear
		(let*	((layer (car (gimp-layer-new image width height RGBA-IMAGE name opacity mode))))
			(gimp-image-insert-layer image layer 0 position)
			(gimp-edit-clear layer)
			layer
	)	)
	(gimp-context-push)
	(let*	(	(trans-bg? #t) ; always
				(xscale (/ width 512)) (xscale40 (* 40 xscale)) (xscale432 (* 432 xscale))
				(yscale (/ height 286))(yscale40 (* 40 yscale)) (yscale50 (* 50 yscale)) (yscale90 (* 90 yscale))
				(radius2 (max (/ (min (* yscale 176) xscale432) 2) 2)) (radius4 (* 2 radius2)) (radius0_6 (* 0.6 radius2))
				(WHITE '(255 255 255))	(BLACK '(0 0 0))
				(image (car (gimp-image-new width height RGB)))
				;; Set new selections for the fore and background-color.
				(reflh	(layer-new image width height "Top Reflect" 80	0 LAYER-MODE-SCREEN-LEGACY))
				(lum	(layer-new image width height "light"	coullt	1 LAYER-MODE-OVERLAY-LEGACY))
				(base	(layer-new image width height "Base"		90 	2 LAYER-MODE-NORMAL-LEGACY))
				(ombre	(layer-new image width height "Shadow"		70 	3 LAYER-MODE-NORMAL-LEGACY))
				(fond	(layer-new image width height "Background" 100	4 LAYER-MODE-NORMAL-LEGACY))
			)
		(define	(selzone img layer col)
			(and (> layer 0) (gimp-edit-clear layer) (gimp-context-set-foreground col)(gimp-edit-fill layer FILL-FOREGROUND))
			(if	(> width height)
				(let*	(	(maxscale (max xscale yscale)) (minscale (min xscale yscale)) (diffscale (- maxscale minscale)))
					(gimp-image-select-ellipse img CHANNEL-OP-REPLACE xscale40 yscale40 radius4 radius4)
					(gimp-image-select-ellipse img CHANNEL-OP-ADD (- (* 472 xscale) radius4) yscale40 radius4 radius4)
					(gimp-image-select-rectangle img CHANNEL-OP-ADD (+ xscale40 radius2) yscale40 (- xscale432 radius4) radius4)
				)
				(gimp-image-select-ellipse img CHANNEL-OP-REPLACE xscale40 yscale40 xscale432 (* 176 yscale))
		)	)
		(gimp-image-undo-disable image)
		(gimp-context-set-background WHITE)
		(gimp-context-set-foreground coulbg) ;; fill the background
		(if	trans-bg? (gimp-drawable-fill fond FILL-TRANSPARENT) (gimp-edit-fill fond FILL-FOREGROUND))
		(let* ((maskbase (car (gimp-layer-create-mask base ADD-MASK-ALPHA)))) 
			(gimp-layer-add-mask base maskbase) ;;;;move1
			(selzone image maskbase WHITE)
			(gimp-context-set-foreground coulfg)
			(colop-switch image base 0 0 width height #t #f)
			(gimp-selection-shrink image (/ radius2 1.52))
			(gimp-context-set-foreground '(160 160 160))
			(gimp-edit-fill maskbase FILL-FOREGROUND)
			(gimp-selection-none image)
			(plug-in-gauss-rle2 TRUE image maskbase (/ radius2 1.19) (/ radius2 1.19))
			(gimp-item-set-visible maskbase FALSE)
		)
		(if	(and (= disp? TRUE) (> coulop 0)) (script-fu-disp image base coulop coulgrad coultex width height))
		(selzone image 0 0) ;; Make shadow
		(gimp-selection-translate image 0 yscale50)
		(gimp-context-set-foreground coulfg)
		(gimp-edit-fill ombre FILL-FOREGROUND)
		(colop-switch image ombre (/ width 5) (/ height 5) (/ width 0.9) (/ height 0.9) #f #t)
		(gimp-selection-none image)
		(plug-in-gauss-rle2 TRUE image ombre (/ radius2 2.5) (/ radius2 2.5))
		(gimp-context-set-foreground coulfg)
		(let* ((maskombre (car (gimp-layer-create-mask ombre ADD-MASK-ALPHA))))
			(gimp-layer-add-mask ombre maskombre) ;;;;moved2
			(selzone image maskombre BLACK)
			(gimp-selection-invert image)
			(gimp-edit-clear maskombre)
			(gimp-item-set-visible maskombre FALSE)
		)
		(gimp-selection-none image) ;; make light
		(selzone image lum BLACK)
		(gimp-selection-shrink image (/ radius2 2.92))
		(gimp-selection-translate image 0 (* 45 yscale))
		(gimp-context-set-foreground WHITE)
		(gimp-edit-fill lum FILL-FOREGROUND)
		(gimp-selection-none image)
		(plug-in-gauss-rle2 TRUE image lum (/ radius2 2.26) (/ radius2 2.26))
		(gimp-selection-none image) ;; Top reflect
		(if	(> width height)
			(begin	(gimp-image-select-ellipse image CHANNEL-OP-REPLACE (+ xscale40 radius0_6) yscale40 radius0_6 radius0_6)
					(gimp-image-select-ellipse image CHANNEL-OP-ADD (- (* 472 xscale) (* 1.2 radius2)) yscale40 radius0_6 radius0_6)
					(gimp-image-select-rectangle image CHANNEL-OP-ADD (+ xscale40 (* radius2 0.9)) yscale40 (- xscale432 (* radius2 1.8)) radius0_6)
			)
			(gimp-image-select-ellipse image CHANNEL-OP-REPLACE (+ xscale40 (* 0.2 radius2)) yscale40 (- xscale432 (* 0.4 radius2)) (* 176 yscale 0.3))
		)
		(gimp-context-set-foreground BLACK)
		(gimp-drawable-fill reflh FILL-TRANSPARENT)
		(gimp-edit-blend reflh BLEND-FG-BG-HSV LAYER-MODE-NORMAL-LEGACY GRADIENT-LINEAR 100 0 REPEAT-NONE FALSE 0 0 0 0 (* 256 xscale) (* 87 yscale) (* 256 xscale) yscale40)
		(gimp-item-transform-perspective reflh (+ (* 52 xscale) radius0_6) yscale50 (- (* 460 xscale) radius0_6) yscale50 
											   (+ (* 30 xscale) radius0_6) yscale90 (- (* 482 xscale) radius0_6) yscale90
		)
		(gimp-floating-sel-anchor (car (gimp-image-get-floating-sel image)))
		(gimp-image-set-active-layer image fond)
		(gimp-context-pop)
		(gimp-image-undo-enable image)
		(list image (car (gimp-display-new image)) fond		  ombre  base lum   reflh)
)	) ; Return (image display                      background shadow base light top_reflect)
(define (gimp-context-pop-flush) (gimp-context-pop) (gimp-displays-flush))
(define (script-fu-aquapro2-NoTransBg backgr image bg-color active-layer size) ; AlSchemist 2021
	(gimp-image-undo-group-start image)
	(gimp-context-set-background bg-color)
	(gimp-drawable-fill active-layer FILL-BACKGROUND)
	(gimp-image-set-active-layer image active-layer)
	(let* ((alayer-copy (car (gimp-layer-copy active-layer TRUE))))
		(gimp-image-insert-layer image alayer-copy 0 -1)
		(let*	((acopy-mask (car (gimp-layer-create-mask alayer-copy ADD-MASK-WHITE))))
			(gimp-layer-add-mask alayer-copy acopy-mask)
			(gimp-edit-copy (car (gimp-layer-get-mask backgr)))
			(gimp-floating-sel-anchor (car (gimp-edit-paste acopy-mask FALSE)))
			(gimp-drawable-invert acopy-mask TRUE) ; AlSchemist 2021: invert in linear space
			(gimp-image-select-item image CHANNEL-OP-REPLACE backgr)
			(gimp-selection-shrink image (/ size 9))
			(gimp-selection-feather image (/ size 6))
			(gimp-edit-fill acopy-mask FILL-WHITE)
	)	)
	(gimp-selection-none image)
	(gimp-item-set-visible active-layer FALSE)
	(gimp-image-merge-visible-layers image EXPAND-AS-NECESSARY)
	(gimp-item-set-visible active-layer TRUE)
	(gimp-image-undo-group-end image)
)
(define (script-fu-aquapro2-hrule-round width height foption fg-color bg-color grad tex lt disp? trans-bg? pill? round? baseradius) ; AlSchemist 2021
	(gimp-context-push)
	(let*	(	(listed	(if round? (script-fu-aqua-button2 (/ (* baseradius 1024) 432) (/ (* baseradius 572) 176) foption fg-color bg-color grad tex lt disp?)
							(if	(eqv? pill? TRUE) 
								(script-fu-aqua-button2 (/ (* width 512) 432) (/ (* height 286) 176) foption fg-color bg-color grad tex lt disp?)
								(script-fu-aqua-button2       width                 height           foption fg-color bg-color grad tex lt disp?)
			)	)		)	)
		(if	(eqv? trans-bg? FALSE)
			(let*	(	(image (car listed))
						(yscale (/ (* baseradius 2) 176))      (xscale (/ (* baseradius 2) 432))
						(radius2 (max (/ (if round? (min (* yscale 176) (* xscale 432)) (min height width)) 2) 2))
					)
				(script-fu-aquapro2-NoTransBg (cadddr listed) image bg-color (car (gimp-image-get-active-layer image)) (/ radius2 0.4))
		)	)
		(gimp-context-pop-flush)
)	)
(define	(script-fu-aquapro2-hrule width height foption fg-color bg-color grad tex lt disp? trans-bg? pill?)	;; Ceate an aqua button without text
	(script-fu-aquapro2-hrule-round width height foption fg-color bg-color grad tex lt disp? trans-bg? pill? #f 0)
)
(define	(script-fu-aquapro2-round baseradius foption fg-color bg-color grad tex lt disp? trans-bg?)			;; Ceate a round image
	(script-fu-aquapro2-hrule-round 0	  0		 foption fg-color bg-color grad tex lt disp? trans-bg? #f	 #t baseradius)
)
;; Create an aqua button with text
(define	(script-fu-aquapro2-button text size fontname text-color foption fg-color bg-color grad tex lt disp? trans-bg? add-shadow?)
	(gimp-context-push)
	(let*	(	(img (car (gimp-image-new 256 256 RGB))) (padding (* 2 (/ size 3.5)))
				(text-layer (car (gimp-text-fontname img -1 0 0 text 0 TRUE size PIXELS fontname)))
				(layer-width (car (gimp-drawable-width text-layer)))
				(layer-height (car (gimp-drawable-height text-layer)))
				(width  (* (+ padding layer-width)  (/ 512 432)))
				(height (* (+ padding layer-height) (/ 286 176)))
			)
		(gimp-image-resize img layer-width layer-height 0 0)
		(gimp-item-set-name text-layer "text")
		(let*	((listed (script-fu-aqua-button2 width height foption fg-color bg-color grad tex lt disp?)))
			(gimp-edit-copy text-layer)
			(gimp-image-delete img)
			(let*	(	(image (car listed))
						(active-layer (car (gimp-image-get-active-layer image)))
						(image-width (car (gimp-image-width image)))
						(image-height (car (gimp-image-height image)))
						(new-text-layer (car (gimp-layer-new image image-width image-height RGBA-IMAGE text 100 LAYER-MODE-NORMAL-LEGACY)))
					)
				(gimp-image-undo-group-start image)
				(gimp-drawable-fill new-text-layer FILL-TRANSPARENT)
				(gimp-image-insert-layer image new-text-layer 0 -1)
				(gimp-image-raise-item-to-top image new-text-layer)
				(gimp-image-lower-item image new-text-layer)
				(gimp-image-lower-item image new-text-layer)
				(gimp-image-select-rectangle image CHANNEL-OP-ADD (* image-width (/ 40 512)) (* image-height (/ 40 286)) (* image-width (/ 432 512)) (* image-height (/ 176 286)))
				(gimp-floating-sel-anchor (car (gimp-edit-paste new-text-layer TRUE)))
				(gimp-selection-none image)
				(if	(eqv? add-shadow? TRUE)
					(let*	((text-copy (car (gimp-layer-copy new-text-layer TRUE))))
						(gimp-image-insert-layer image text-copy 0 -1)
						(gimp-image-lower-item image text-copy)
						(gimp-image-lower-item image text-copy)
						(gimp-drawable-offset text-copy TRUE OFFSET-TRANSPARENT (/ size 32) (/ size 8))
						(plug-in-gauss-iir2 1 image text-copy (/ size 9) (/ size 9))
				)	)
				(gimp-image-set-active-layer image new-text-layer)
				(gimp-image-undo-group-end image)
				(if	(eqv? trans-bg? FALSE) (script-fu-aquapro2-NoTransBg (cadddr listed) image bg-color active-layer size))
			)
			(gimp-context-pop-flush)
			listed ; Return '(image display)
)	)	)
;; Create logo in aqua ball
(define	(script-fu-aquapro2-logo-in-pill text size fontname text-color foption fg-color bg-color grad tex lt disp? trans-bg? add-shadow? flatten?)
	; (string-spliter "string  spliter")	(string-spliter "string-spliter")	(string-spliter "012 - 345")	(strbreakup "This is a string" " ")
	;-> ("string" "spliter")				("string-spliter")					("012" "-" "345")				("This" "is" "a" "string")
	(define	(string-spliter str) ; split trimmed str into a list of tokens by AlSchemist 2021                    gĕ𕪂ƊȒPɂȂ̂ŉǂ
		(define (white-space-char? ch) (or (char=? ch #\space) (char=? ch #\tab))) ; evaluates if an character is white-space or not?
		(let*	((lenStr (string-length str)))
			(let loop	((idx 0) (start 0) (lstToken '()))
				(if	(= idx lenStr) (reverse (cons (substring str start idx) lstToken))
					(if (not (white-space-char? (string-ref str idx))) (loop (+ idx 1) start lstToken)
						(let space-again ((idw (+ idx 1)))
							(if	(= idw lenStr) lstToken
								(if (white-space-char? (string-ref str idw)) (space-again (+ idw 1)) ; consecutive white spaces
									(loop idw idw (cons (substring str start idx) lstToken))
	)	)	)	)	)	)	)	)
	(let*	(	(img (car (gimp-image-new 1 1 RGB)))) ; existing image
		(gimp-context-push)
		(gimp-context-set-background bg-color)
		(let loop ((lstToken (string-spliter (string-trim text)))) ; remove white-space from left and right side in text
			(if (pair? lstToken)
				(let*	(	(caption (car lstToken))
							(listed (script-fu-aquapro2-button caption size fontname text-color foption fg-color bg-color grad tex lt disp? trans-bg? add-shadow?))
							(image (car listed)) ; new added image
							(image-width (car (gimp-image-width image)))
							(image-height (car (gimp-image-height image)))
							(img-width (car (gimp-image-width img)))
							(img-height (car (gimp-image-height img)))
							(img-layer (car (gimp-layer-new img image-width (max img-height image-height) RGBA-IMAGE caption 100 LAYER-MODE-NORMAL-LEGACY)))
							(height-mean2 (if (< img-height image-height) 0 (/ (- img-height image-height) 2)))
							(height-mean1 (if (> img-height image-height) 0 (/ (- image-height img-height) 2)))
						)
					(if	(< img-height image-height) (set! img-height image-height))
					(gimp-image-resize img (+ img-width image-width) img-height 0 height-mean1)
					(gimp-image-resize image image-width img-height 0 height-mean2)
					(gimp-drawable-fill img-layer FILL-TRANSPARENT)
					(let*	((layerImage (car (gimp-image-merge-visible-layers image EXPAND-AS-NECESSARY))))
						(gimp-image-insert-layer img img-layer 0 -1)
						(gimp-layer-set-offsets img-layer img-width 0)
						(gimp-edit-copy layerImage)
					)
					(gimp-floating-sel-anchor (car (gimp-edit-paste img-layer 0)))
					(gimp-display-delete (cadr listed)) ;delete image
					(loop (cdr lstToken)) ; next token
		)	)	)
		(gimp-image-undo-group-start img)
		(let*	(	(img-width (car (gimp-image-width img)))
					(img-height (car (gimp-image-height img)))
					(bg-layer (car	(gimp-layer-new img img-width img-height RGBA-IMAGE text 100 LAYER-MODE-NORMAL-LEGACY)))
				)
			(gimp-context-set-background bg-color)
			(gimp-drawable-fill bg-layer (if (eqv? trans-bg? TRUE) FILL-TRANSPARENT FILL-BACKGROUND))
			(gimp-image-insert-layer img bg-layer 0 -1)
			(gimp-image-lower-item-to-bottom img bg-layer)
		)
		(gimp-image-undo-group-end img)
		(if	(eqv? flatten? TRUE)(if	(eqv? trans-bg? TRUE) (gimp-image-merge-visible-layers img EXPAND-AS-NECESSARY)(gimp-image-flatten img)))
		(gimp-context-pop-flush)
		(list img (car (gimp-display-new img)))
)	)	; Return '(image display)
(script-fu-register "script-fu-aquapro2-button" "Aqua _Button" "Create the logo in aqua pill image v2.0" "Iccii <iccii@hotmail.com>" "Iccii, AlSchemist" "2021" ""
	SF-STRING	_"Text"			"Aqua"	SF-ADJUSTMENT _"Font Size (pixels)"	'(100 2 500 1 1 0 1)
	SF-FONT	_"Font"	(if (string=? (substring gimp-data-directory 0 17) "C:\\Program Files\\") "Times New Roman"	"classicheavylight") ; Linux: try also "Proxima Nova Alt"
	SF-COLOR      _"Text Color"		'(  0   0   0)
	SF-OPTION      "Mode"            '(_"COLOR" _"GRADIENT" _"TEXTURE")	SF-COLOR _"Base Color" '(183  71 124)	SF-COLOR _"Background Color" '(255 255 255)
	SF-GRADIENT    "Gradient"        "Pastel Rainbow"		SF-PATTERN "Texture"	"Marble #1"	SF-ADJUSTMENT "lighting" '(100  0 100 1 2 0 0)
	SF-TOGGLE      "Displace"	        TRUE	SF-TOGGLE _"Transparent BG"	FALSE	SF-TOGGLE _"Add Drop-Shadow" TRUE
)
(script-fu-register "script-fu-aquapro2-hrule" "Aqua _Hrule" "Creates a aqua-style button v2.0\n
This script creates a multi-layered aqua button. Thx to Wolfgang Mauerer." "lefinnois@lefinnois.net" "Denis Bodor, AlSchemist"  "2021" ""
	SF-ADJUSTMENT	"Width"			'(512  10 9999 1 10 0 1)
	SF-ADJUSTMENT	"Height"		'(286  10 9999 1 10 0 1)
	SF-OPTION       "Mode"            '(_"COLOR" _"GRADIENT" _"TEXTURE") SF-COLOR _"Foreground Color" '( 71 124 183) SF-COLOR _"Background Color" '(0 0 0)
	SF-GRADIENT     "Gradient"        "Pastel Rainbow"		SF-PATTERN "Texture" "Marble #1"	SF-ADJUSTMENT "lighting" '(100  0 100 1 2 0 0)
	SF-TOGGLE       "Displace"	        TRUE	SF-TOGGLE _"Transparent BG"	FALSE	SF-TOGGLE _"Pill's Width and Height?" FALSE
)
(script-fu-register "script-fu-aquapro2-logo-in-pill" "Aqua _Logo in pill" "Create logos in aqua pill v2.0" "Iccii <iccii@hotmail.com>" "Iccii, AlSchemist" "2021" ""
	SF-STRING		_"Text"				"012 - 345"	SF-ADJUSTMENT _"Font Size (pixels)"	'(75 2 500 1 1 0 1)
	SF-FONT	_"Font" (if (string=? (substring gimp-data-directory 0 17) "C:\\Program Files\\") "Times New Roman"	"classicheavylight") ; Linux: try also "Proxima Nova Alt"
	SF-COLOR      _"Text Color"			'(  0   0   0)
	SF-OPTION      "Mode"				'(_"COLOR" _"GRADIENT" _"TEXTURE")	SF-COLOR _"Base Color" '(124 183  71)	SF-COLOR _"Background Color" '(255 255 255)
	SF-GRADIENT    "Gradient"			"Pastel Rainbow"	SF-PATTERN "Texture" "Marble #1"	SF-ADJUSTMENT  "lighting" '(100  0 100 1 2 0 0)
	SF-TOGGLE      "Displace"	        TRUE
	SF-TOGGLE     _"Transparent BG"		FALSE	SF-TOGGLE _"Add Drop-Shadow" TRUE	SF-TOGGLE _"Flatten Image" TRUE
)
(script-fu-register "script-fu-aquapro2-round" "Aqua _Round" "Creates a aqua-style round button v2.0" "Iccii <iccii@hotmail.com>" "Iccii, AlSchemist" "2021" ""
	SF-ADJUSTMENT	"Base Radius (pixels)"	'(60 2 1024 1 1 0 1)
	SF-OPTION       "Mode"            '(_"COLOR" _"GRADIENT" _"TEXTURE")	SF-COLOR _"Foreground Color" '(71 183 124)	SF-COLOR _"Background Color" '(255 255 255)
	SF-GRADIENT     "Gradient"        "Pastel Rainbow"		SF-PATTERN "Texture" "Marble #1"	SF-ADJUSTMENT	"lighting" '(100  0 100 1 2 0 0)
	SF-TOGGLE       "Displace"	        TRUE	SF-TOGGLE _"Transparent BG"	FALSE
)
(map (lambda (fnc) (script-fu-menu-register (string-append "script-fu-aquapro2-" fnc) "<Image>/File/Create/_AquaPro2")) '("button" "hrule" "logo-in-pill" "round"))